searchNodes=[{"ref":"Wasmex.html","title":"Wasmex","type":"module","doc":"Wasmex is an Elixir library for executing WebAssembly binaries. WASM files can be executed using a WebAssembly Wasmex.Instance: {:ok, bytes } = File.read(&quot;wasmex_test.wasm&quot;) {:ok, instance } = Wasmex.Instance.from_bytes(bytes) instance |&gt; Wasmex.Instance.call_exported_function(&quot;sum&quot;, [50, -8]) Memory can be read/written using Wasmex.Memory: offset = 7 index = 4 value = 42 {:ok, memory} = Wasmex.Instance.memory(instance, :uint8, offset) Wasmex.Memory.set(memory, index, value) IO.puts Wasmex.Memory.get(memory, index) # 42"},{"ref":"Wasmex.Instance.html","title":"Wasmex.Instance","type":"module","doc":"Instantiates a WebAssembly module represented by bytes and allows calling exported functions on it. # Get the Wasm module as bytes. {:ok, bytes } = File.read(&quot;wasmex_test.wasm&quot;) # Instantiates the Wasm module. {:ok, instance } = Wasmex.Instance.from_bytes(bytes) # Call a function on it. result = Wasmex.Instance.call_exported_function(instance, &quot;sum&quot;, [1, 2]) IO.puts result # 3 All exported functions are accessible via the call_exported_function function. Arguments of these functions are automatically casted to WebAssembly values. Note that WebAssembly only knows number datatypes (floats and integers of various sizes). You can pass arbitrary data to WebAssembly, though, by writing this data into its memory. The memory function returns a Memory struct representing the memory of that particular instance, e.g.: {:ok, memory} = Wasmex.Instance.memory(instance, :uint8, 0)"},{"ref":"Wasmex.Instance.html#call_exported_function/2","title":"Wasmex.Instance.call_exported_function/2","type":"function","doc":""},{"ref":"Wasmex.Instance.html#call_exported_function/3","title":"Wasmex.Instance.call_exported_function/3","type":"function","doc":""},{"ref":"Wasmex.Instance.html#from_bytes/1","title":"Wasmex.Instance.from_bytes/1","type":"function","doc":""},{"ref":"Wasmex.Instance.html#function_export_exists/2","title":"Wasmex.Instance.function_export_exists/2","type":"function","doc":""},{"ref":"Wasmex.Instance.html#memory/3","title":"Wasmex.Instance.memory/3","type":"function","doc":""},{"ref":"Wasmex.Instance.html#t:t/0","title":"Wasmex.Instance.t/0","type":"type","doc":""},{"ref":"Wasmex.Memory.html","title":"Wasmex.Memory","type":"module","doc":"A WebAssembly instance has its own memory, represented by the Memory struct. It is accessible by the Wasmex.Instance.memory getter. The Memory.grow methods allows to grow the memory by a number of pages (of 65kb each). Wasmex.Memory.grow(memory, 1) The current size of the memory can be obtained with the length method: Wasmex.Memory.length(memory) # in bytes, always a multiple of the the page size (65kb) When creating the memory struct, the offset param can be provided, to subset the memory array at a particular offset. offset = 7 index = 4 value = 42 {:ok, memory} = Wasmex.Instance.memory(instance, :uint8, offset) Wasmex.Memory.set(memory, index, value) IO.puts Wasmex.Memory.get(memory, index) # 42 The Memory struct views the WebAssembly memory of an instance as an array of values of different types. Possible types are: uint8, int8, uint16, int16, uint32, and int32. The underlying data is not changed when viewed in different types - its just its representation that changes. View memory buffer as a sequence of…Bytes per element int81 uint81 int162 uint162 int324 uint324"},{"ref":"Wasmex.Memory.html#bytes_per_element/1","title":"Wasmex.Memory.bytes_per_element/1","type":"function","doc":"Returns the number of bytes used to represent a unit in memory. For the limited number of unit sizes the byte values are the following: size | Bytes per element | |----------|---| | int8 | 1 | | uint8 | 1 | | int16 | 2 | | uint16 | 2 | | int32 | 4 | | uint32 | 4 | {:ok, memory} = Wasmex.Instance.memory(instance, :uint16, 0) Wasmex.Memory.bytes_per_element(memory) # 2"},{"ref":"Wasmex.Memory.html#bytes_per_element/3","title":"Wasmex.Memory.bytes_per_element/3","type":"function","doc":"Same as bytes_per_element/1 except the unit size and offset given at memory creation are overwritten by the given values. {:ok, memory} = Wasmex.Instance.memory(instance) Wasmex.Memory.bytes_per_element(memory, :uint32, 0) # 4"},{"ref":"Wasmex.Memory.html#from_instance/1","title":"Wasmex.Memory.from_instance/1","type":"function","doc":""},{"ref":"Wasmex.Memory.html#from_instance/3","title":"Wasmex.Memory.from_instance/3","type":"function","doc":""},{"ref":"Wasmex.Memory.html#get/2","title":"Wasmex.Memory.get/2","type":"function","doc":""},{"ref":"Wasmex.Memory.html#get/4","title":"Wasmex.Memory.get/4","type":"function","doc":""},{"ref":"Wasmex.Memory.html#grow/2","title":"Wasmex.Memory.grow/2","type":"function","doc":"Grows the amount of available memory by the given number of pages and returns the number of previously available pages. Note that the maximum number of pages is 65_536"},{"ref":"Wasmex.Memory.html#grow/4","title":"Wasmex.Memory.grow/4","type":"function","doc":""},{"ref":"Wasmex.Memory.html#length/1","title":"Wasmex.Memory.length/1","type":"function","doc":"Returns the number of elements that fit into memory for the given unit size and offset. Note that the WebAssembly memory consists of pages of 65kb each. Different unit sizes needs a different number of bytes per element and the offset may reduce the number of available elements. {:ok, memory} = Wasmex.Memory.from_instance(instance, :uint8, 0) Wasmex.Memory.length(memory) # 1114112 (17 * 65_536)"},{"ref":"Wasmex.Memory.html#length/3","title":"Wasmex.Memory.length/3","type":"function","doc":"Same as length/1 except the unit size and offset given at memory creation are overwritten by the given values. {:ok, memory} = Wasmex.Instance.memory(instance) Wasmex.Memory.length(memory, :uint8, 0) # 1114112 (17 * 65_536)"},{"ref":"Wasmex.Memory.html#read_binary/2","title":"Wasmex.Memory.read_binary/2","type":"function","doc":""},{"ref":"Wasmex.Memory.html#read_binary/4","title":"Wasmex.Memory.read_binary/4","type":"function","doc":""},{"ref":"Wasmex.Memory.html#set/3","title":"Wasmex.Memory.set/3","type":"function","doc":""},{"ref":"Wasmex.Memory.html#set/5","title":"Wasmex.Memory.set/5","type":"function","doc":""},{"ref":"Wasmex.Memory.html#write_binary/3","title":"Wasmex.Memory.write_binary/3","type":"function","doc":""},{"ref":"Wasmex.Memory.html#write_binary/5","title":"Wasmex.Memory.write_binary/5","type":"function","doc":""},{"ref":"Wasmex.Memory.html#t:t/0","title":"Wasmex.Memory.t/0","type":"type","doc":""},{"ref":"Wasmex.Native.html","title":"Wasmex.Native","type":"module","doc":"Contains calls that are implemented in our Rust NIF. Functions in this module are not intended to be called directly."},{"ref":"Wasmex.Native.html#instance_call_exported_function/3","title":"Wasmex.Native.instance_call_exported_function/3","type":"function","doc":""},{"ref":"Wasmex.Native.html#instance_function_export_exists/2","title":"Wasmex.Native.instance_function_export_exists/2","type":"function","doc":""},{"ref":"Wasmex.Native.html#instance_new_from_bytes/1","title":"Wasmex.Native.instance_new_from_bytes/1","type":"function","doc":""},{"ref":"Wasmex.Native.html#memory_bytes_per_element/3","title":"Wasmex.Native.memory_bytes_per_element/3","type":"function","doc":""},{"ref":"Wasmex.Native.html#memory_from_instance/1","title":"Wasmex.Native.memory_from_instance/1","type":"function","doc":""},{"ref":"Wasmex.Native.html#memory_get/4","title":"Wasmex.Native.memory_get/4","type":"function","doc":""},{"ref":"Wasmex.Native.html#memory_grow/4","title":"Wasmex.Native.memory_grow/4","type":"function","doc":""},{"ref":"Wasmex.Native.html#memory_length/3","title":"Wasmex.Native.memory_length/3","type":"function","doc":""},{"ref":"Wasmex.Native.html#memory_read_binary/4","title":"Wasmex.Native.memory_read_binary/4","type":"function","doc":""},{"ref":"Wasmex.Native.html#memory_set/5","title":"Wasmex.Native.memory_set/5","type":"function","doc":""},{"ref":"Wasmex.Native.html#memory_write_binary/5","title":"Wasmex.Native.memory_write_binary/5","type":"function","doc":""}]